---
title: Introduction to Space
next: /why-space/
next_title: "Why Space"
weight: 100
giturl: github.com/space-sh/space
editurl: /edit/master/doc/introduction-to-space/index.md
icon: "<b>1. </b>"
---

# Introduction to Space

_Space.sh_, or simply _Space_, is an open source automation software for the _Internet of Things_ and digital life.  

_Space_ is a single-file, dependency-free, command-line program written in _Bash_ programming language. It offers a parser and preprocessor for creating and executing user-authored content described in a _YAML-like_ declarative language and shell scripts.  

_Space_ relies on base _UNIX-like_ command line utilities and offers users the ability to describe more complex behaviors and create reusable content called modules. _Space_ modules can be mixed and matched with each other and then exported as a _POSIX-compliant_ standalone application for sharing.  
One of _Space's_ most basic use-case is enabling infrastructure communication and automation.  

Other typical actions of _Space_:  
1. Create a _Space_ module, or download an existing one, then run operations with a single command  
2. Export an entire module or part of it as standalone program for sharing or replicating somewhere else  
3. Create a new _Space_ module derived from an existing one  
4. Run a _Space_ module operation wrapped around another Module's function, like a command line hook  

_Space_ was first publicly available on November 30th, 2016, and it is part of _Space.sh_.  

The next section talks about ["why"](../why-space/#content) _Space_ has been created, the reason behind it and project goals.  
For code examples, refer to [Installing and running your first Space command](../installing-and-running-your-first-space-command/#content) section.


