---
prev: ../
prev_title: "Why Space"
next: /how-space-works/
next_title: "How Space works"
title: Benefits and advantages of using Space
giturl: github.com/space-sh/space
editurl: /edit/master/doc/why-space/benefits-and-advantages-of-using-space.md
weight: 201
---

# Benefits and advantages of using Space

- **Solid foundation**: based on tried-and-true _POSIX-compatible_ environment
- **Embedded and IoT friendly**: compact codebase and single file distribution
- **Simple**: single-file makes it easier for running and setting up local or system-wide installs
- **Efficient**: no code bloat policy leads to a small executable with around 5K lines of code
- **Small**: less than 200K bytes in size
- **Fast**: leverages existing core system command line utilities
- **Intuitive**: shell integration and smart tab completions
- **No dependencies**: _Bash_ is available everywhere
- **Compatible**: follows _POSIX-like_ philosophy and standards
- **Configurable**: ability to use the preprocessor for tweakable settings
- **Extensible**: ability to expand the core concepts and creating derivative programs with _Space_ modules
- **Composable**: modules can be combined to quickly create new programs, giving great flexibility
- **Decentralized content**: distributed user-content by design
- **Exportable**: possibility to build standalone programs for more secure deployments by exporting _Space_ modules where any redundant code has been removed by tree-shaking, for easy inspection
- **Agentless**: no agents required for running commands on remote targets  

